/*
 *    Compaq Hot Plug Controller Graphical User Interface 
 *    Copyright 2000, 2001 Compaq Computer Corporation
 *    All rights reserved.
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE, GOOD TITLE or
 *    NON INFRINGEMENT.  See the GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    Please send all questions or concerns to linuxhotplug@compaq.com
 */

#include "commonheader.h"
#include "style.h"

void set_tree_style(GdkColor n_color, GdkColor s_color, GtkCTree* tree, GtkCTreeNode* node, GdkFont* font) 
{
        GtkStyle* style = make_style(n_color, s_color, font);
	
	gtk_ctree_node_set_row_style(tree, node, style);
}

GtkStyle* make_style(GdkColor n_color, GdkColor s_color, GdkFont* font)
{
        GtkStyle* style;

        style = gtk_widget_get_default_style();
        style = gtk_style_copy(style);
        style->fg[GTK_STATE_NORMAL] = n_color;
        style->fg[GTK_STATE_SELECTED] = s_color;

        style->font = font;

	return style;
}
